<?php
/**
 * Clase Base DP para BaseCrCreditoCronoComentarioDP
 *
 * @package    
 * @subpackage BaseCrCreditoCronoComentarioDP
 * @author     Willy
 * @version    SVN:: BaseCrCreditoCronoComentarioDP.class.php,v 1.1 2013-04-19 11:08:00 william.taype Exp $
 */
abstract class BaseCrCreditoCronoComentarioDP extends CrCreditoCronoComentarioBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCreditoCronoComentarioBN )
    {
      $o_CrCreditoCronoComentarioBN = $bSetDefault;
      if($o_CrCreditoCronoComentarioBN->getIdcreditocronocomentario()) : $this->setIdcreditocronocomentario($o_CrCreditoCronoComentarioBN->getIdcreditocronocomentario()); endif;
      if($o_CrCreditoCronoComentarioBN->getIdcreditocrono()) : $this->setIdcreditocrono($o_CrCreditoCronoComentarioBN->getIdcreditocrono()); endif;
      if($o_CrCreditoCronoComentarioBN->getFechatrx()) : $this->setFechatrx($o_CrCreditoCronoComentarioBN->getFechatrx()); endif;
      if($o_CrCreditoCronoComentarioBN->getComentario()) : $this->setComentario($o_CrCreditoCronoComentarioBN->getComentario()); endif;
      if($o_CrCreditoCronoComentarioBN->getFechacreacion()) : $this->setFechacreacion($o_CrCreditoCronoComentarioBN->getFechacreacion()); endif;
      if($o_CrCreditoCronoComentarioBN->getIdcolaboradorref()) : $this->setIdcolaboradorref($o_CrCreditoCronoComentarioBN->getIdcolaboradorref()); endif;
      if($o_CrCreditoCronoComentarioBN->getNombrecolaboradorref()) : $this->setNombrecolaboradorref($o_CrCreditoCronoComentarioBN->getNombrecolaboradorref()); endif;
      if($o_CrCreditoCronoComentarioBN->getUsuariocreacion()) : $this->setUsuariocreacion($o_CrCreditoCronoComentarioBN->getUsuariocreacion()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(idcreditocronocomentario),(MAX(idcreditocronocomentario)+1), 1) AS Maximo FROM cr_credito_crono_comentario;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdcreditocronocomentario($row[0]);

      if($this->getIdcreditocronocomentario()){
        $a_Fields = array();

        if($this->getIdcreditocronocomentario()) : $a_Fields['idcreditocronocomentario'] = ($this->getIdcreditocronocomentario()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;
        if($this->getFechatrx()) : $a_Fields['fechatrx'] = ($this->getFechatrx()); endif;
        if($this->getComentario()) : $a_Fields['comentario'] = ($this->getComentario()); endif;
        if($this->getFlagConfidencial()) : $a_Fields['flagconfidencial'] = ($this->getFlagConfidencial()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getIdcolaboradorref()) : $a_Fields['idcolaboradorref'] = ($this->getIdcolaboradorref()); endif;
        if($this->getNombrecolaboradorref()) : $a_Fields['nombrecolaboradorref'] = ($this->getNombrecolaboradorref()); endif;
        if($this->getUsuariocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsuariocreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_credito_crono_comentario (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdcreditocronocomentario())
      {
        $a_Fields = array();

        if($this->getIdcreditocronocomentario()) : $a_Fields['idcreditocronocomentario'] = ($this->getIdcreditocronocomentario()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;
        if($this->getFechatrx()) : $a_Fields['fechatrx'] = ($this->getFechatrx()); endif;
        if($this->getComentario()) : $a_Fields['comentario'] = ($this->getComentario()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getIdcolaboradorref()) : $a_Fields['idcolaboradorref'] = ($this->getIdcolaboradorref()); endif;
        if($this->getNombrecolaboradorref()) : $a_Fields['nombrecolaboradorref'] = ($this->getNombrecolaboradorref()); endif;
        if($this->getUsuariocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsuariocreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_credito_crono_comentario SET ".$sStringField." WHERE 1 AND idcreditocronocomentario='".$this->getIdcreditocronocomentario()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdcreditocronocomentario())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_credito_crono_comentario WHERE 1 AND idcreditocronocomentario='".$this->getIdcreditocronocomentario()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdcreditocronocomentario)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcreditocronocomentario, idcreditocrono, fechatrx, comentario, fechacreacion, idcolaboradorref, nombrecolaboradorref, usuariocreacion FROM cr_credito_crono_comentario WHERE 1 AND idcreditocronocomentario='".$vIdcreditocronocomentario."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCreditoCronoComentarioDP = new CrCreditoCronoComentarioDP();
    $o_CrCreditoCronoComentarioDP->setIdcreditocronocomentario($o_propel->idcreditocronocomentario);
    $o_CrCreditoCronoComentarioDP->setIdcreditocrono($o_propel->idcreditocrono);
    $o_CrCreditoCronoComentarioDP->setFechatrx($o_propel->fechatrx);
    $o_CrCreditoCronoComentarioDP->setComentario($o_propel->comentario);
    $o_CrCreditoCronoComentarioDP->setFechacreacion($o_propel->fechacreacion);
    $o_CrCreditoCronoComentarioDP->setFlagConfidencial($o_propel->flagconfidencial);
    $o_CrCreditoCronoComentarioDP->setIdcolaboradorref($o_propel->idcolaboradorref);
    $o_CrCreditoCronoComentarioDP->setNombrecolaboradorref($o_propel->nombrecolaboradorref);
    $o_CrCreditoCronoComentarioDP->setUsuariocreacion($o_propel->usuariocreacion);
    return $o_CrCreditoCronoComentarioDP;
  }
}